import requests

# encoding: utf-8
import threadpool
import threading
import re
import requests as requests
import requests.packages.urllib3
requests.packages.urllib3.disable_warnings()
import random
import optparse

allow_ssl_verify = False

timeout = 10
pathlist = [x for x in open('path.txt').read().split('\n')]
# 是否允许URL重定向
allow_redirects = True

# 是否允许继承http Request类的Session支持，在发出的所有请求之间保持cookies。
allow_http_session = False

# 是否允许随机User-Agent
allow_random_useragent = True

# 是否允许随机X-Forwarded-For
allow_random_x_forward = True

# 代理配置
proxies = {
    # "http": "http://user:pass@10.10.1.10:3128/",
    # "https": "http://10.10.1.10:1080",
    # "http": "http://127.0.0.1:8118", # TOR 洋葱路由器
    #"socks5": "socks5://127.0.0.1:1086"
}

# 随机HTTP头
USER_AGENTS = [
    "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_3) AppleWebKit/535.20 (KHTML, like Gecko) Chrome/19.0.1036.7 Safari/535.20",
    "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; AcooBrowser; .NET CLR 1.1.4322; .NET CLR 2.0.50727)",
    "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0; Acoo Browser; SLCC1; .NET CLR 2.0.50727; Media Center PC 5.0; .NET CLR 3.0.04506)",
    "Mozilla/4.0 (compatible; MSIE 7.0; AOL 9.5; AOLBuild 4337.35; Windows NT 5.1; .NET CLR 1.1.4322; .NET CLR 2.0.50727)",
    "Mozilla/5.0 (Windows; U; MSIE 9.0; Windows NT 9.0; en-US)",
    "Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; Win64; x64; Trident/5.0; .NET CLR 3.5.30729; .NET CLR 3.0.30729; .NET CLR 2.0.50727; Media Center PC 6.0)",
    "Mozilla/5.0 (compatible; MSIE 8.0; Windows NT 6.0; Trident/4.0; WOW64; Trident/4.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; .NET CLR 1.0.3705; .NET CLR 1.1.4322)",
    "Mozilla/4.0 (compatible; MSIE 7.0b; Windows NT 5.2; .NET CLR 1.1.4322; .NET CLR 2.0.50727; InfoPath.2; .NET CLR 3.0.04506.30)",
    "Mozilla/5.0 (Windows; U; Windows NT 5.1; zh-CN) AppleWebKit/523.15 (KHTML, like Gecko, Safari/419.3) Arora/0.3 (Change: 287 c9dfb30)",
    "Mozilla/5.0 (X11; U; Linux; en-US) AppleWebKit/527+ (KHTML, like Gecko, Safari/419.3) Arora/0.6",
    "Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.2pre) Gecko/20070215 K-Ninja/2.1.1",
    "Mozilla/5.0 (Windows; U; Windows NT 5.1; zh-CN; rv:1.9) Gecko/20080705 Firefox/3.0 Kapiko/3.0",
    "Mozilla/5.0 (X11; Linux i686; U;) Gecko/20070322 Kazehakase/0.4.5",
    "Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.0.8) Gecko Fedora/1.9.0.8-1.fc10 Kazehakase/0.5.6",
    "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/535.11 (KHTML, like Gecko) Chrome/17.0.963.56 Safari/535.11",
    "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_3) AppleWebKit/535.20 (KHTML, like Gecko) Chrome/19.0.1036.7 Safari/535.20",
    "Opera/9.80 (Macintosh; Intel Mac OS X 10.6.8; U; fr) Presto/2.9.168 Version/11.52",
]

lock = threading.Lock()

# 随机生成User-Agent
def random_useragent(condition=False):
    if condition:
        return random.choice(USER_AGENTS)
    else:
        return USER_AGENTS[0]


# 随机X-Forwarded-For，动态IP
def random_x_forwarded_for(condition=False):
    if condition:
        return '%d.%d.%d.%d' % (
            random.randint(1, 254), random.randint(1, 254), random.randint(1, 254), random.randint(1, 254))
    else:
        return '8.8.8.8'


# HTTP 头设置
headers = {
    'User-Agent': random_useragent(allow_random_useragent),
    'X-Forwarded-For': random_x_forwarded_for(allow_random_x_forward),
    'Referer': 'http://www.baidu.com',
    'Cookie': "",
}

#path
if allow_http_session:
    requests = requests.Session()

with open('finger.txt') as f:
    config_ini = f.readlines()

def http_request_get(url, body_content_workflow=False, allow_redirects=allow_redirects, custom_cookie="", timeout=5):
    try:
        if custom_cookie:
            headers['Cookie'] = custom_cookie
        result = requests.get(url,
                              stream=body_content_workflow,
                              headers=headers,
                              timeout=timeout,
                              proxies=proxies,
                              allow_redirects=allow_redirects,
                              verify=allow_ssl_verify)
        return True,result
    except Exception, e:
        #print e
        # return empty requests object
        return False,None

def service_http(url):
    title_str = ''
    cms = ''
    flag,resp = http_request_get(url=url)
    if flag:
        status_code = resp.status_code
        html = resp.content
        header_Length = 0 if 'Content-Length' not in resp.headers else resp.headers['Content-Length']
        header_server = '' if 'Server' not in resp.headers else resp.headers['Server']
        header = resp.headers
        try:
            title = re.search(r'<title>(.*?)</title>', html, flags=re.I | re.M)
            if title: title_str = title.group(1)
        except:
            pass
        for mark_info in config_ini:
            mark_info = mark_info.strip('\n').split('|')
            if mark_info[1] == 'header':
                try:
                    if re.search(mark_info[3], header[mark_info[2]], re.I):
                        cms = mark_info[0]
                except Exception, e:
                    continue
            elif mark_info[1] == 'file':
                try:
                    if re.search(mark_info[3], html, re.I):
                        cms = mark_info[0]
                except Exception, e:
                    continue
        lock.acquire()
        print status_code,title_str.ljust(5),cms.ljust(5),url,header_Length,header_server
        lock.release()

if __name__ == '__main__':
    parser = optparse.OptionParser()
    parser.add_option('-u','--url',help='please input url')
    parser.add_option('-f','--file',help='please input file')
    parser.add_option('-i','--ip',help='please input ip')
    (options,args) = parser.parse_args()
    if options.url:
        url = options.url
        if not (url.startswith('https://') or url.startswith('http://')):
            url = 'https://'+url
        #print '[*]Now Scanning:'+url
        try:
            for p in pathlist:
                service_http(url+'/%s'%p)
        except Exception,e:
            print e
    if options.file:
        file = options.file
        url_lists = []
        with open(file) as inFile:
            lines = inFile.readlines()
        for line in lines:
            url = line.strip('\n')
            if not (url.startswith('https://') or url.startswith('http://')):
                url_1 = 'http://'+url
                url_https = 'https://'+url
            for p in path:
                url_lists.append(url_1+'/%s'%p)
                url_lists.append(url_https+'/%s'%p)
        #print url_lists
    if options.ip:
        ip = options.ip
        url_lists=[]
        for i in range(0,255):
            url_https = 'https://'+ip+"."+str(i)
            url_lists.append(url_https)
    pool = threadpool.ThreadPool(10)
    reqs = threadpool.makeRequests(service_http, url_lists)
    [pool.putRequest(req) for req in reqs]
    pool.wait()
    pool.dismissWorkers(20, do_join=True)
